import * as React from "react";
import { Checkbox } from "office-ui-fabric-react/lib/Checkbox";
import styles from "./Checklist.module.scss";
export default function Checklist(props) {
    var _a = React.useState(props.items ? props.items : []), items = _a[0], setItems = _a[1];
    var _b = React.useState(props.checkedKeys ? props.checkedKeys : []), checkedKeys = _b[0], setCheckedKeys = _b[1];
    var onCheckboxChange = function (ev, isChecked, item) {
        if (isChecked)
            setCheckedKeys(checkedKeys.concat([item.key]));
        else
            setCheckedKeys(checkedKeys.filter(function (key) { return key != item.key; }));
    };
    var isItemChecked = function (key) {
        var checkedItem = checkedKeys.filter(function (item) { return item == key; })[0];
        if (checkedItem)
            return true;
        return false;
    };
    var labelShortener = function (label) {
        var shortlabel = label;
        if (shortlabel.length > 30) {
            return shortlabel.slice(0, 30) + "...";
        }
        return shortlabel;
    };
    React.useEffect(function () {
        props.onChanged(checkedKeys);
    }, [checkedKeys]);
    React.useEffect(function () {
        if (props.checkedKeys)
            setCheckedKeys(props.checkedKeys);
    }, [props.checkedKeys]);
    React.useEffect(function () {
        if (props.items)
            setItems(props.items);
    }, [props.items]);
    return (React.createElement("div", { className: styles.container },
        React.createElement("label", { className: styles.propertylabel }, props.label),
        React.createElement("div", { className: styles.itemContainer }, items.map(function (item, index) {
            return (React.createElement(Checkbox, { key: index, className: styles.item, disabled: props.disabled, onRenderLabel: function () {
                    return (React.createElement("span", { className: styles.itemText }, labelShortener(item.text + " (" + item.subText + ")")));
                }, defaultChecked: isItemChecked(item.key), onChange: function (ev, isChecked) {
                    return onCheckboxChange(ev, isChecked, item);
                } }));
        }))));
}
//# sourceMappingURL=Checklist.js.map